/// <reference types="cypress" />
import DataTable from "@cucumber/cucumber/lib/models/data_table";
import { IHookBody, IParameterTypeDefinition, IStepDefinitionBody } from "./types";
export declare class Registry {
    methods: {
        Given<T extends unknown[]>(description: string | RegExp, body: IStepDefinitionBody<T>): void;
        When<T extends unknown[]>(description: string | RegExp, body: IStepDefinitionBody<T>): void;
        Then<T extends unknown[]>(description: string | RegExp, body: IStepDefinitionBody<T>): void;
        Step(world: Mocha.Context, description: string, argument?: DataTable | string): void;
        defineParameterType<T>(options: IParameterTypeDefinition<T>): void;
        Before(this: Mocha.Context, options: {
            tags?: string;
        }, fn: IHookBody): void;
        Before(this: Mocha.Context, fn: IHookBody): void;
        After(this: Mocha.Context, options: {
            tags?: string;
        }, fn: IHookBody): void;
        After(this: Mocha.Context, fn: IHookBody): void;
    };
    private parameterTypeRegistry;
    private stepDefinitions;
    private beforeHooks;
    private afterHooks;
    constructor();
    private defineStep;
    private defineParameterType;
    private defineBefore;
    private defineAfter;
    private resolveStepDefintion;
    runStepDefininition(world: Mocha.Context, text: string, argument?: DataTable | string): void;
    runBeforeHooks(world: Mocha.Context, tags: string[]): void;
    runAfterHooks(world: Mocha.Context, tags: string[]): void;
}
declare const _default: Registry;
export default _default;
